/*
 *  Copyright 2007-2008, Plutext Pty Ltd.
 *
 *  This file is part of docx4j.

    docx4j is licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.

    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

 */


package org.docx4j.dml;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for CT_ShapeProperties complex type.
 *
 * <p>The following schema fragment specifies the expected content contained within this class.
 *
 * <pre>
 * &lt;complexType name="CT_ShapeProperties">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="xfrm" type="{http://schemas.openxmlformats.org/drawingml/2006/main}CT_Transform2D" minOccurs="0"/>
 *         &lt;group ref="{http://schemas.openxmlformats.org/drawingml/2006/main}EG_Geometry" minOccurs="0"/>
 *         &lt;group ref="{http://schemas.openxmlformats.org/drawingml/2006/main}EG_FillProperties" minOccurs="0"/>
 *         &lt;element name="ln" type="{http://schemas.openxmlformats.org/drawingml/2006/main}CT_LineProperties" minOccurs="0"/>
 *         &lt;group ref="{http://schemas.openxmlformats.org/drawingml/2006/main}EG_EffectProperties" minOccurs="0"/>
 *         &lt;element name="scene3d" type="{http://schemas.openxmlformats.org/drawingml/2006/main}CT_Scene3D" minOccurs="0"/>
 *         &lt;element name="sp3d" type="{http://schemas.openxmlformats.org/drawingml/2006/main}CT_Shape3D" minOccurs="0"/>
 *         &lt;element name="extLst" type="{http://schemas.openxmlformats.org/drawingml/2006/main}CT_OfficeArtExtensionList" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="bwMode" type="{http://schemas.openxmlformats.org/drawingml/2006/main}ST_BlackWhiteMode" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 *
 *
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CT_ShapeProperties", propOrder = {
    "xfrm",
    "custGeom",
    "prstGeom",
    "noFill",
    "solidFill",
    "gradFill",
    "blipFill",
    "pattFill",
    "grpFill",
    "ln",
    "effectLst",
    "effectDag",
    "scene3D",
    "sp3D",
    "extLst"
})
public class CTShapeProperties implements IFillProperties, ITransform2DAccessor {

    protected CTTransform2D xfrm;
    protected CTCustomGeometry2D custGeom;
    protected CTPresetGeometry2D prstGeom;
    protected CTNoFillProperties noFill;
    protected CTSolidColorFillProperties solidFill;
    protected CTGradientFillProperties gradFill;
    protected CTBlipFillProperties blipFill;
    protected CTPatternFillProperties pattFill;
    protected CTGroupFillProperties grpFill;
    protected CTLineProperties ln;
    protected CTEffectList effectLst;
    protected CTEffectContainer effectDag;
    @XmlElement(name = "scene3d")
    protected CTScene3D scene3D;
    @XmlElement(name = "sp3d")
    protected CTShape3D sp3D;
    protected CTOfficeArtExtensionList extLst;
    @XmlAttribute
    protected STBlackWhiteMode bwMode;

    /**
     * Gets the value of the xfrm property.
     *
     * @return
     *     possible object is
     *     {@link CTTransform2D }
     *
     */
    @Override
    public CTTransform2D getXfrm(boolean forceCreate) {
    	if(xfrm==null&&forceCreate) {
    		xfrm = new CTTransform2D();
    	}
        return xfrm;
    }

    /**
     * Gets the value of the custGeom property.
     *
     * @return
     *     possible object is
     *     {@link CTCustomGeometry2D }
     *
     */
    public CTCustomGeometry2D getCustGeom() {
        return custGeom;
    }

    /**
     * Sets the value of the custGeom property.
     *
     * @param value
     *     allowed object is
     *     {@link CTCustomGeometry2D }
     *
     */
    public void setCustGeom(CTCustomGeometry2D value) {
        this.custGeom = value;
    }

    /**
     * Gets the value of the prstGeom property.
     *
     * @return
     *     possible object is
     *     {@link CTPresetGeometry2D }
     *
     */
    public CTPresetGeometry2D getPrstGeom() {
        return prstGeom;
    }

    /**
     * Sets the value of the prstGeom property.
     *
     * @param value
     *     allowed object is
     *     {@link CTPresetGeometry2D }
     *
     */
    public void setPrstGeom(CTPresetGeometry2D value) {
        this.prstGeom = value;
    }

    /**
     * Gets the value of the noFill property.
     *
     * @return
     *     possible object is
     *     {@link CTNoFillProperties }
     *
     */
    public CTNoFillProperties getNoFill() {
        return noFill;
    }

    /**
     * Sets the value of the noFill property.
     *
     * @param value
     *     allowed object is
     *     {@link CTNoFillProperties }
     *
     */
    public void setNoFill(CTNoFillProperties value) {
        this.noFill = value;
    }

    /**
     * Gets the value of the solidFill property.
     *
     * @return
     *     possible object is
     *     {@link CTSolidColorFillProperties }
     *
     */
    public CTSolidColorFillProperties getSolidFill() {
        return solidFill;
    }

    /**
     * Sets the value of the solidFill property.
     *
     * @param value
     *     allowed object is
     *     {@link CTSolidColorFillProperties }
     *
     */
    public void setSolidFill(CTSolidColorFillProperties value) {
        this.solidFill = value;
    }

    /**
     * Gets the value of the gradFill property.
     *
     * @return
     *     possible object is
     *     {@link CTGradientFillProperties }
     *
     */
    public CTGradientFillProperties getGradFill() {
        return gradFill;
    }

    /**
     * Sets the value of the gradFill property.
     *
     * @param value
     *     allowed object is
     *     {@link CTGradientFillProperties }
     *
     */
    public void setGradFill(CTGradientFillProperties value) {
        this.gradFill = value;
    }

    /**
     * Gets the value of the blipFill property.
     *
     * @return
     *     possible object is
     *     {@link CTBlipFillProperties }
     *
     */
    public CTBlipFillProperties getBlipFill() {
        return blipFill;
    }

    /**
     * Sets the value of the blipFill property.
     *
     * @param value
     *     allowed object is
     *     {@link CTBlipFillProperties }
     *
     */
    public void setBlipFill(CTBlipFillProperties value) {
        this.blipFill = value;
    }

    /**
     * Gets the value of the pattFill property.
     *
     * @return
     *     possible object is
     *     {@link CTPatternFillProperties }
     *
     */
    public CTPatternFillProperties getPattFill() {
        return pattFill;
    }

    /**
     * Sets the value of the pattFill property.
     *
     * @param value
     *     allowed object is
     *     {@link CTPatternFillProperties }
     *
     */
    public void setPattFill(CTPatternFillProperties value) {
        this.pattFill = value;
    }

    /**
     * Gets the value of the grpFill property.
     *
     * @return
     *     possible object is
     *     {@link CTGroupFillProperties }
     *
     */
    public CTGroupFillProperties getGrpFill() {
        return grpFill;
    }

    /**
     * Sets the value of the grpFill property.
     *
     * @param value
     *     allowed object is
     *     {@link CTGroupFillProperties }
     *
     */
    public void setGrpFill(CTGroupFillProperties value) {
        this.grpFill = value;
    }

    /**
     * Gets the value of the ln property.
     *
     * @return
     *     possible object is
     *     {@link CTLineProperties }
     *
     */
    public CTLineProperties getLn() {
        return ln;
    }

    /**
     * Sets the value of the ln property.
     *
     * @param value
     *     allowed object is
     *     {@link CTLineProperties }
     *
     */
    public void setLn(CTLineProperties value) {
        this.ln = value;
    }

    /**
     * Gets the value of the effectLst property.
     *
     * @return
     *     possible object is
     *     {@link CTEffectList }
     *
     */
    public CTEffectList getEffectLst() {
        return effectLst;
    }

    /**
     * Sets the value of the effectLst property.
     *
     * @param value
     *     allowed object is
     *     {@link CTEffectList }
     *
     */
    public void setEffectLst(CTEffectList value) {
        this.effectLst = value;
    }

    /**
     * Gets the value of the effectDag property.
     *
     * @return
     *     possible object is
     *     {@link CTEffectContainer }
     *
     */
    public CTEffectContainer getEffectDag() {
        return effectDag;
    }

    /**
     * Sets the value of the effectDag property.
     *
     * @param value
     *     allowed object is
     *     {@link CTEffectContainer }
     *
     */
    public void setEffectDag(CTEffectContainer value) {
        this.effectDag = value;
    }

    /**
     * Gets the value of the scene3D property.
     *
     * @return
     *     possible object is
     *     {@link CTScene3D }
     *
     */
    public CTScene3D getScene3D() {
        return scene3D;
    }

    /**
     * Sets the value of the scene3D property.
     *
     * @param value
     *     allowed object is
     *     {@link CTScene3D }
     *
     */
    public void setScene3D(CTScene3D value) {
        this.scene3D = value;
    }

    /**
     * Gets the value of the sp3D property.
     *
     * @return
     *     possible object is
     *     {@link CTShape3D }
     *
     */
    public CTShape3D getSp3D() {
        return sp3D;
    }

    /**
     * Sets the value of the sp3D property.
     *
     * @param value
     *     allowed object is
     *     {@link CTShape3D }
     *
     */
    public void setSp3D(CTShape3D value) {
        this.sp3D = value;
    }

    /**
     * Gets the value of the extLst property.
     *
     * @return
     *     possible object is
     *     {@link CTOfficeArtExtensionList }
     *
     */
    public CTOfficeArtExtensionList getExtLst() {
        return extLst;
    }

    /**
     * Sets the value of the extLst property.
     *
     * @param value
     *     allowed object is
     *     {@link CTOfficeArtExtensionList }
     *
     */
    public void setExtLst(CTOfficeArtExtensionList value) {
        this.extLst = value;
    }

    /**
     * Gets the value of the bwMode property.
     *
     * @return
     *     possible object is
     *     {@link STBlackWhiteMode }
     *
     */
    public STBlackWhiteMode getBwMode() {
        return bwMode;
    }

    /**
     * Sets the value of the bwMode property.
     *
     * @param value
     *     allowed object is
     *     {@link STBlackWhiteMode }
     *
     */
    public void setBwMode(STBlackWhiteMode value) {
        this.bwMode = value;
    }
}
