/*
 *  Copyright 2010-2013, Plutext Pty Ltd.
 *
 *  This file is part of xlsx4j, a component of docx4j.

    docx4j is licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.

    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

 */
package org.xlsx4j.sml;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import org.xlsx4j.jaxb.Context;


/**
 * <p>Java class for CT_GradientStop complex type.
 *
 * <p>The following schema fragment specifies the expected content contained within this class.
 *
 * <pre>
 * &lt;complexType name="CT_GradientStop">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="color" type="{http://schemas.openxmlformats.org/spreadsheetml/2006/main}CT_Color"/>
 *       &lt;/sequence>
 *       &lt;attribute name="position" use="required" type="{http://www.w3.org/2001/XMLSchema}double" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 *
 *
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CT_GradientStop", propOrder = {
    "color"
})
public class CTGradientStop implements Cloneable
{

    @XmlElement(required = true)
    protected CTColor color;
    @XmlAttribute(name = "position", required = true)
    protected double position;

    public CTGradientStop clone() {
        final CTGradientStop clone = Context.getsmlObjectFactory().createCTGradientStop();
        if(color!=null) {
            clone.color = color.clone();
        }
        clone.position = position;
        return clone;
    }

    /**
     * Gets the value of the color property.
     *
     * @return
     *     possible object is
     *     {@link CTColor }
     *
     */
    public CTColor getColor() {
        return color;
    }

    /**
     * Sets the value of the color property.
     *
     * @param value
     *     allowed object is
     *     {@link CTColor }
     *
     */
    public void setColor(CTColor value) {
        this.color = value;
    }

    /**
     * Gets the value of the position property.
     *
     */
    public double getPosition() {
        return position;
    }

    /**
     * Sets the value of the position property.
     *
     */
    public void setPosition(double value) {
        this.position = value;
    }
}
