package com.openexchange.office.json.tools;

import java.util.Set;

import com.openexchange.session.Session;

public class FakeSession
        implements
        Session
{

    private final Integer userId;
    private final Session realSession;

    public FakeSession(
            int userId, Session realSession)
    {
        this.userId = userId;
        this.realSession = realSession;
    }

    @Override
    public int getUserId()
    {
        return userId;
    }

    @Override
    public int getContextId()
    {
        return realSession.getContextId();
    }

    @Override
    public String getLocalIp()
    {

        return realSession.getLocalIp();
    }

    @Deprecated
    @Override
    public void setLocalIp(
        String ip)
    {
        realSession.setLocalIp(ip);
    }

    @Override
    public String getLoginName()
    {

        return realSession.getLoginName();
    }

    @Override
    public boolean containsParameter(
        String name)
    {

        return realSession.containsParameter(name);
    }

    @Override
    public Object getParameter(
        String name)
    {

        return realSession.getParameter(name);
    }

    @Override
    public String getPassword()
    {

        return realSession.getPassword();
    }

    @Override
    public String getRandomToken()
    {

        return realSession.getRandomToken();
    }

    @Override
    public String getSecret()
    {

        return realSession.getSecret();
    }

    @Override
    public String getSessionID()
    {

        return realSession.getSessionID();
    }

    @Override
    public String getUserlogin()
    {

        return realSession.getUserlogin();
    }

    @Override
    public String getLogin()
    {

        return realSession.getLogin();
    }

    @Override
    public void setParameter(
        String name,
        Object value)
    {
        realSession.setParameter(name, value);
    }

    @Override
    public String getAuthId()
    {

        return realSession.getAuthId();
    }

    @Override
    public String getHash()
    {

        return realSession.getHash();
    }

    @Deprecated
    @Override
    public void setHash(
        String hash)
    {
        realSession.setHash(hash);
    }

    @Override
    public String getClient()
    {

        return realSession.getClient();
    }

    @Deprecated
    @Override
    public void setClient(
        String client)
    {
        realSession.setClient(client);
    }

    @Override
    public boolean isTransient()
    {

        return realSession.isTransient();
    }

    @Override
    public Set<String> getParameterNames()
    {
        return realSession.getParameterNames();
    }

}
